<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHierarchyElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfHierarchyElement extends AbstractStructArrayBase
{
    /**
     * The HierarchyElement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HierarchyElement[]
     */
    public $HierarchyElement;
    /**
     * Constructor method for ArrayOfHierarchyElement
     * @uses ArrayOfHierarchyElement::setHierarchyElement()
     * @param \StructType\HierarchyElement[] $hierarchyElement
     */
    public function __construct(array $hierarchyElement = array())
    {
        $this
            ->setHierarchyElement($hierarchyElement);
    }
    /**
     * Get HierarchyElement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HierarchyElement[]|null
     */
    public function getHierarchyElement()
    {
        return isset($this->HierarchyElement) ? $this->HierarchyElement : null;
    }
    /**
     * Set HierarchyElement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HierarchyElement[] $hierarchyElement
     * @return \ArrayType\ArrayOfHierarchyElement
     */
    public function setHierarchyElement(array $hierarchyElement = array())
    {
        foreach ($hierarchyElement as $arrayOfHierarchyElementHierarchyElementItem) {
            // validation for constraint: itemType
            if (!$arrayOfHierarchyElementHierarchyElementItem instanceof \StructType\HierarchyElement) {
                throw new \InvalidArgumentException(sprintf('The HierarchyElement property can only contain items of \StructType\HierarchyElement, "%s" given', is_object($arrayOfHierarchyElementHierarchyElementItem) ? get_class($arrayOfHierarchyElementHierarchyElementItem) : gettype($arrayOfHierarchyElementHierarchyElementItem)), __LINE__);
            }
        }
        if (is_null($hierarchyElement) || (is_array($hierarchyElement) && empty($hierarchyElement))) {
            unset($this->HierarchyElement);
        } else {
            $this->HierarchyElement = $hierarchyElement;
        }
        return $this;
    }
    /**
     * Add item to HierarchyElement value
     * @throws \InvalidArgumentException
     * @param \StructType\HierarchyElement $item
     * @return \ArrayType\ArrayOfHierarchyElement
     */
    public function addToHierarchyElement(\StructType\HierarchyElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HierarchyElement) {
            throw new \InvalidArgumentException(sprintf('The HierarchyElement property can only contain items of \StructType\HierarchyElement, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HierarchyElement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HierarchyElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HierarchyElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HierarchyElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HierarchyElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HierarchyElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HierarchyElement
     */
    public function getAttributeName()
    {
        return 'HierarchyElement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHierarchyElement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
