<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLanguageString ArrayType
 * @subpackage Arrays
 */
class ArrayOfLanguageString extends AbstractStructArrayBase
{
    /**
     * The CompleteText
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LanguageString[]
     */
    public $CompleteText;
    /**
     * Constructor method for ArrayOfLanguageString
     * @uses ArrayOfLanguageString::setCompleteText()
     * @param \StructType\LanguageString[] $completeText
     */
    public function __construct(array $completeText = array())
    {
        $this
            ->setCompleteText($completeText);
    }
    /**
     * Get CompleteText value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LanguageString[]|null
     */
    public function getCompleteText()
    {
        return isset($this->CompleteText) ? $this->CompleteText : null;
    }
    /**
     * Set CompleteText value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageString[] $completeText
     * @return \ArrayType\ArrayOfLanguageString
     */
    public function setCompleteText(array $completeText = array())
    {
        foreach ($completeText as $arrayOfLanguageStringCompleteTextItem) {
            // validation for constraint: itemType
            if (!$arrayOfLanguageStringCompleteTextItem instanceof \StructType\LanguageString) {
                throw new \InvalidArgumentException(sprintf('The CompleteText property can only contain items of \StructType\LanguageString, "%s" given', is_object($arrayOfLanguageStringCompleteTextItem) ? get_class($arrayOfLanguageStringCompleteTextItem) : gettype($arrayOfLanguageStringCompleteTextItem)), __LINE__);
            }
        }
        if (is_null($completeText) || (is_array($completeText) && empty($completeText))) {
            unset($this->CompleteText);
        } else {
            $this->CompleteText = $completeText;
        }
        return $this;
    }
    /**
     * Add item to CompleteText value
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageString $item
     * @return \ArrayType\ArrayOfLanguageString
     */
    public function addToCompleteText(\StructType\LanguageString $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LanguageString) {
            throw new \InvalidArgumentException(sprintf('The CompleteText property can only contain items of \StructType\LanguageString, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CompleteText[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LanguageString|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LanguageString|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LanguageString|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LanguageString|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LanguageString|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CompleteText
     */
    public function getAttributeName()
    {
        return 'CompleteText';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLanguageString
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
