<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLanguageString14 ArrayType
 * @subpackage Arrays
 */
class ArrayOfLanguageString14 extends AbstractStructArrayBase
{
    /**
     * The CustomNavigationNext
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LanguageString[]
     */
    public $CustomNavigationNext;
    /**
     * Constructor method for ArrayOfLanguageString14
     * @uses ArrayOfLanguageString14::setCustomNavigationNext()
     * @param \StructType\LanguageString[] $customNavigationNext
     */
    public function __construct(array $customNavigationNext = array())
    {
        $this
            ->setCustomNavigationNext($customNavigationNext);
    }
    /**
     * Get CustomNavigationNext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LanguageString[]|null
     */
    public function getCustomNavigationNext()
    {
        return isset($this->CustomNavigationNext) ? $this->CustomNavigationNext : null;
    }
    /**
     * Set CustomNavigationNext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageString[] $customNavigationNext
     * @return \ArrayType\ArrayOfLanguageString14
     */
    public function setCustomNavigationNext(array $customNavigationNext = array())
    {
        foreach ($customNavigationNext as $arrayOfLanguageString14CustomNavigationNextItem) {
            // validation for constraint: itemType
            if (!$arrayOfLanguageString14CustomNavigationNextItem instanceof \StructType\LanguageString) {
                throw new \InvalidArgumentException(sprintf('The CustomNavigationNext property can only contain items of \StructType\LanguageString, "%s" given', is_object($arrayOfLanguageString14CustomNavigationNextItem) ? get_class($arrayOfLanguageString14CustomNavigationNextItem) : gettype($arrayOfLanguageString14CustomNavigationNextItem)), __LINE__);
            }
        }
        if (is_null($customNavigationNext) || (is_array($customNavigationNext) && empty($customNavigationNext))) {
            unset($this->CustomNavigationNext);
        } else {
            $this->CustomNavigationNext = $customNavigationNext;
        }
        return $this;
    }
    /**
     * Add item to CustomNavigationNext value
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageString $item
     * @return \ArrayType\ArrayOfLanguageString14
     */
    public function addToCustomNavigationNext(\StructType\LanguageString $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LanguageString) {
            throw new \InvalidArgumentException(sprintf('The CustomNavigationNext property can only contain items of \StructType\LanguageString, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CustomNavigationNext[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LanguageString|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LanguageString|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LanguageString|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LanguageString|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LanguageString|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomNavigationNext
     */
    public function getAttributeName()
    {
        return 'CustomNavigationNext';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLanguageString14
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
