<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLanguageString8 ArrayType
 * @subpackage Arrays
 */
class ArrayOfLanguageString8 extends AbstractStructArrayBase
{
    /**
     * The HelpLinkText
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LanguageString[]
     */
    public $HelpLinkText;
    /**
     * Constructor method for ArrayOfLanguageString8
     * @uses ArrayOfLanguageString8::setHelpLinkText()
     * @param \StructType\LanguageString[] $helpLinkText
     */
    public function __construct(array $helpLinkText = array())
    {
        $this
            ->setHelpLinkText($helpLinkText);
    }
    /**
     * Get HelpLinkText value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LanguageString[]|null
     */
    public function getHelpLinkText()
    {
        return isset($this->HelpLinkText) ? $this->HelpLinkText : null;
    }
    /**
     * Set HelpLinkText value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageString[] $helpLinkText
     * @return \ArrayType\ArrayOfLanguageString8
     */
    public function setHelpLinkText(array $helpLinkText = array())
    {
        foreach ($helpLinkText as $arrayOfLanguageString8HelpLinkTextItem) {
            // validation for constraint: itemType
            if (!$arrayOfLanguageString8HelpLinkTextItem instanceof \StructType\LanguageString) {
                throw new \InvalidArgumentException(sprintf('The HelpLinkText property can only contain items of \StructType\LanguageString, "%s" given', is_object($arrayOfLanguageString8HelpLinkTextItem) ? get_class($arrayOfLanguageString8HelpLinkTextItem) : gettype($arrayOfLanguageString8HelpLinkTextItem)), __LINE__);
            }
        }
        if (is_null($helpLinkText) || (is_array($helpLinkText) && empty($helpLinkText))) {
            unset($this->HelpLinkText);
        } else {
            $this->HelpLinkText = $helpLinkText;
        }
        return $this;
    }
    /**
     * Add item to HelpLinkText value
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageString $item
     * @return \ArrayType\ArrayOfLanguageString8
     */
    public function addToHelpLinkText(\StructType\LanguageString $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LanguageString) {
            throw new \InvalidArgumentException(sprintf('The HelpLinkText property can only contain items of \StructType\LanguageString, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HelpLinkText[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LanguageString|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LanguageString|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LanguageString|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LanguageString|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LanguageString|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HelpLinkText
     */
    public function getAttributeName()
    {
        return 'HelpLinkText';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLanguageString8
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
