<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetDatabaseLastCompiled' => '\\StructType\\GetDatabaseLastCompiled',
            'GetDatabaseLastCompiledResponse' => '\\StructType\\GetDatabaseLastCompiledResponse',
            'AddProjectFromTripleS' => '\\StructType\\AddProjectFromTripleS',
            'SssSchema' => '\\StructType\\SssSchema',
            'SssSurvey' => '\\StructType\\SssSurvey',
            'SpecializedTexts' => '\\StructType\\SpecializedTexts',
            'SssText' => '\\StructType\\SssText',
            'SssRecord' => '\\StructType\\SssRecord',
            'SssVariable' => '\\StructType\\SssVariable',
            'SssPosition' => '\\StructType\\SssPosition',
            'SssSpread' => '\\StructType\\SssSpread',
            'ArrayOfChoice1' => '\\StructType\\ArrayOfChoice1',
            'SssRange' => '\\StructType\\SssRange',
            'SssValueBase' => '\\StructType\\SssValueBase',
            'SssValue' => '\\StructType\\SssValue',
            'SssHierarchy' => '\\StructType\\SssHierarchy',
            'SssLevel' => '\\StructType\\SssLevel',
            'SssParent' => '\\StructType\\SssParent',
            'SssQuantum' => '\\StructType\\SssQuantum',
            'AddProjectFromTripleSResponse' => '\\StructType\\AddProjectFromTripleSResponse',
            'GetProjectList' => '\\StructType\\GetProjectList',
            'ProjectListToken' => '\\StructType\\ProjectListToken',
            'GetProjectListResponse' => '\\StructType\\GetProjectListResponse',
            'ProjectListResultSet' => '\\StructType\\ProjectListResultSet',
            'ProjectList' => '\\StructType\\ProjectList',
            'ProjectListBase' => '\\StructType\\ProjectListBase',
            'ArrayOfProject' => '\\ArrayType\\ArrayOfProject',
            'Project' => '\\StructType\\Project',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'GetProjectListByProjectName' => '\\StructType\\GetProjectListByProjectName',
            'GetProjectListByProjectNameResponse' => '\\StructType\\GetProjectListByProjectNameResponse',
            'GetProjectListByCreator' => '\\StructType\\GetProjectListByCreator',
            'GetProjectListByCreatorResponse' => '\\StructType\\GetProjectListByCreatorResponse',
            'GetProjectListByKeywords' => '\\StructType\\GetProjectListByKeywords',
            'ArrayOfString1' => '\\ArrayType\\ArrayOfString1',
            'GetProjectListByKeywordsResponse' => '\\StructType\\GetProjectListByKeywordsResponse',
            'GetProjectListByCreatedDate' => '\\StructType\\GetProjectListByCreatedDate',
            'GetProjectListByCreatedDateResponse' => '\\StructType\\GetProjectListByCreatedDateResponse',
            'AddProject' => '\\StructType\\AddProject',
            'AddProjectResponse' => '\\StructType\\AddProjectResponse',
            'DeleteProject' => '\\StructType\\DeleteProject',
            'DeleteProjectResponse' => '\\StructType\\DeleteProjectResponse',
            'DuplicateProject' => '\\StructType\\DuplicateProject',
            'DuplicateProjectResponse' => '\\StructType\\DuplicateProjectResponse',
            'SetCustomProjectInfoField' => '\\StructType\\SetCustomProjectInfoField',
            'SetCustomProjectInfoFieldResponse' => '\\StructType\\SetCustomProjectInfoFieldResponse',
            'GetCustomProjectInfoField' => '\\StructType\\GetCustomProjectInfoField',
            'GetCustomProjectInfoFieldResponse' => '\\StructType\\GetCustomProjectInfoFieldResponse',
            'GetProjectInfo' => '\\StructType\\GetProjectInfo',
            'GetProjectInfoResponse' => '\\StructType\\GetProjectInfoResponse',
            'SurveySchema' => '\\StructType\\SurveySchema',
            'ReadFilter' => '\\StructType\\ReadFilter',
            'ReadFilterSimple' => '\\StructType\\ReadFilterSimple',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'PoetReadFilter' => '\\StructType\\PoetReadFilter',
            'ArrayOfNodeType' => '\\ArrayType\\ArrayOfNodeType',
            'Root' => '\\StructType\\Root',
            'Node' => '\\StructType\\Node',
            'PredefinedList' => '\\StructType\\PredefinedList',
            'ArrayOfChoice15' => '\\StructType\\ArrayOfChoice15',
            'HeaderAnswer' => '\\StructType\\HeaderAnswer',
            'AnswerBase' => '\\StructType\\AnswerBase',
            'LoopMember' => '\\StructType\\LoopMember',
            'ArrayOfAnswerText' => '\\ArrayType\\ArrayOfAnswerText',
            'AnswerText' => '\\StructType\\AnswerText',
            'HeaderAnswerEnd' => '\\StructType\\HeaderAnswerEnd',
            'LoopLevelReference' => '\\StructType\\LoopLevelReference',
            'HieararchyAnswer' => '\\StructType\\HieararchyAnswer',
            'ArrayOfHierarchyNode' => '\\ArrayType\\ArrayOfHierarchyNode',
            'HierarchyNode' => '\\StructType\\HierarchyNode',
            'HierarchyLevel' => '\\StructType\\HierarchyLevel',
            'Predefined' => '\\StructType\\Predefined',
            'GridAnswer' => '\\StructType\\GridAnswer',
            'ArrayOfGridAnswerText' => '\\ArrayType\\ArrayOfGridAnswerText',
            'GridAnswerText' => '\\StructType\\GridAnswerText',
            'Answer' => '\\StructType\\Answer',
            'AdditionalColumnAnswer' => '\\StructType\\AdditionalColumnAnswer',
            'ArrayOfTranslationStatus' => '\\ArrayType\\ArrayOfTranslationStatus',
            'TranslationStatus' => '\\StructType\\TranslationStatus',
            'ProjectInfo' => '\\StructType\\ProjectInfo',
            'ArrayOfLanguageString7' => '\\ArrayType\\ArrayOfLanguageString7',
            'LanguageString' => '\\StructType\\LanguageString',
            'ArrayOfLanguageString8' => '\\ArrayType\\ArrayOfLanguageString8',
            'ArrayOfLanguageString9' => '\\ArrayType\\ArrayOfLanguageString9',
            'ArrayOfLanguageString10' => '\\ArrayType\\ArrayOfLanguageString10',
            'ArrayOfLanguageString11' => '\\ArrayType\\ArrayOfLanguageString11',
            'ArrayOfLanguageString12' => '\\ArrayType\\ArrayOfLanguageString12',
            'ArrayOfLanguageString13' => '\\ArrayType\\ArrayOfLanguageString13',
            'ArrayOfLanguageString14' => '\\ArrayType\\ArrayOfLanguageString14',
            'ArrayOfCustomResource' => '\\ArrayType\\ArrayOfCustomResource',
            'CustomResource' => '\\StructType\\CustomResource',
            'ArrayOfLangSpecString' => '\\ArrayType\\ArrayOfLangSpecString',
            'LangSpecString' => '\\StructType\\LangSpecString',
            'Questionnaire' => '\\StructType\\Questionnaire',
            'ArrayOfPredefinedList' => '\\ArrayType\\ArrayOfPredefinedList',
            'ArrayOfEmail' => '\\ArrayType\\ArrayOfEmail',
            'Email' => '\\StructType\\Email',
            'QuestionnaireNode' => '\\StructType\\QuestionnaireNode',
            'QuestionnaireNodeFlexSupport' => '\\StructType\\QuestionnaireNodeFlexSupport',
            'FormBase' => '\\StructType\\FormBase',
            'ArrayOfFormText' => '\\ArrayType\\ArrayOfFormText',
            'FormText' => '\\StructType\\FormText',
            'ArrayOfString2' => '\\ArrayType\\ArrayOfString2',
            'QuestionFormBase' => '\\StructType\\QuestionFormBase',
            'MultiForm' => '\\StructType\\MultiForm',
            'ArrayOfChoice6' => '\\StructType\\ArrayOfChoice6',
            'PredefinedScriptBase' => '\\StructType\\PredefinedScriptBase',
            'IncludeExcludeWithPrecodes' => '\\StructType\\IncludeExcludeWithPrecodes',
            'RandomCategorySelection' => '\\StructType\\RandomCategorySelection',
            'Redirect' => '\\StructType\\Redirect',
            'IncludeExclude' => '\\StructType\\IncludeExclude',
            'AssignRequestValues' => '\\StructType\\AssignRequestValues',
            'MaskOnQuestion' => '\\StructType\\MaskOnQuestion',
            'OpenForm' => '\\StructType\\OpenForm',
            'GridForm' => '\\StructType\\GridForm',
            'ArrayOfChoice4' => '\\StructType\\ArrayOfChoice4',
            'ArrayOfChoice5' => '\\StructType\\ArrayOfChoice5',
            'SingleForm' => '\\StructType\\SingleForm',
            'ArrayOfChoice3' => '\\StructType\\ArrayOfChoice3',
            'Hierarchy' => '\\StructType\\Hierarchy',
            'ExternalLookup' => '\\StructType\\ExternalLookup',
            'CustomTable' => '\\StructType\\CustomTable',
            'ArrayOfHierarchyElement' => '\\ArrayType\\ArrayOfHierarchyElement',
            'HierarchyElement' => '\\StructType\\HierarchyElement',
            'Grid3DForm' => '\\StructType\\Grid3DForm',
            'ArrayOfChoice7' => '\\StructType\\ArrayOfChoice7',
            'ArrayOfChoice8' => '\\StructType\\ArrayOfChoice8',
            'InfoForm' => '\\StructType\\InfoForm',
            'Folder' => '\\StructType\\Folder',
            'ArrayOfChoice10' => '\\StructType\\ArrayOfChoice10',
            'Script' => '\\StructType\\Script',
            'Condition' => '\\StructType\\Condition',
            'ArrayOfChoice11' => '\\StructType\\ArrayOfChoice11',
            'Directive' => '\\StructType\\Directive',
            'Page' => '\\StructType\\Page',
            'ArrayOfChoice9' => '\\StructType\\ArrayOfChoice9',
            'ArrayOfLanguageString2' => '\\ArrayType\\ArrayOfLanguageString2',
            'Stop' => '\\StructType\\Stop',
            'ArrayOfLanguageString' => '\\ArrayType\\ArrayOfLanguageString',
            'ArrayOfLanguageString1' => '\\ArrayType\\ArrayOfLanguageString1',
            'CallBlock' => '\\StructType\\CallBlock',
            'Block' => '\\StructType\\Block',
            'ArrayOfChoice13' => '\\StructType\\ArrayOfChoice13',
            'Loop' => '\\StructType\\Loop',
            'ArrayOfChoice2' => '\\StructType\\ArrayOfChoice2',
            'ArrayOfChoice14' => '\\StructType\\ArrayOfChoice14',
            'Telephone' => '\\StructType\\Telephone',
            'BaseTelephoneCommand' => '\\StructType\\BaseTelephoneCommand',
            'DialCommand' => '\\StructType\\DialCommand',
            'ArrayOfCommandText' => '\\ArrayType\\ArrayOfCommandText',
            'CommandText' => '\\StructType\\CommandText',
            'AllowIgnoreDialingCommand' => '\\StructType\\AllowIgnoreDialingCommand',
            'HangupCommand' => '\\StructType\\HangupCommand',
            'ArrayOfChoice12' => '\\StructType\\ArrayOfChoice12',
            'ArrayOfLanguageString3' => '\\ArrayType\\ArrayOfLanguageString3',
            'ArrayOfLanguageString4' => '\\ArrayType\\ArrayOfLanguageString4',
            'ArrayOfLanguageString5' => '\\ArrayType\\ArrayOfLanguageString5',
            'ArrayOfLanguageString6' => '\\ArrayType\\ArrayOfLanguageString6',
            'ArrayOfChoice16' => '\\StructType\\ArrayOfChoice16',
            'ArrayOfBlock' => '\\ArrayType\\ArrayOfBlock',
            'ArrayOfQuota' => '\\ArrayType\\ArrayOfQuota',
            'Quota' => '\\StructType\\Quota',
            'ArrayOfFormReference' => '\\ArrayType\\ArrayOfFormReference',
            'FormReference' => '\\StructType\\FormReference',
            'ArrayOfChoice17' => '\\StructType\\ArrayOfChoice17',
            'GetQuestionnaire' => '\\StructType\\GetQuestionnaire',
            'GetQuestionnaireResponse' => '\\StructType\\GetQuestionnaireResponse',
            'GetFilteredQuestionnaire' => '\\StructType\\GetFilteredQuestionnaire',
            'GetFilteredQuestionnaireResponse' => '\\StructType\\GetFilteredQuestionnaireResponse',
            'ExportSurvey' => '\\StructType\\ExportSurvey',
            'ExportSurveyResponse' => '\\StructType\\ExportSurveyResponse',
            'ExportSurveyLayout' => '\\StructType\\ExportSurveyLayout',
            'ExportSurveyLayoutResponse' => '\\StructType\\ExportSurveyLayoutResponse',
            'ExportSurveyWithHTMLRemoved' => '\\StructType\\ExportSurveyWithHTMLRemoved',
            'ExportSurveyWithHTMLRemovedResponse' => '\\StructType\\ExportSurveyWithHTMLRemovedResponse',
            'ImportSurvey' => '\\StructType\\ImportSurvey',
            'ImportSurveyResponse' => '\\StructType\\ImportSurveyResponse',
            'ImportTranslation' => '\\StructType\\ImportTranslation',
            'ImportTranslationResponse' => '\\StructType\\ImportTranslationResponse',
            'ExportTranslation' => '\\StructType\\ExportTranslation',
            'ExportTranslationResponse' => '\\StructType\\ExportTranslationResponse',
            'GetPredefinedLists' => '\\StructType\\GetPredefinedLists',
            'GetPredefinedListsResponse' => '\\StructType\\GetPredefinedListsResponse',
            'GetPredefinedList' => '\\StructType\\GetPredefinedList',
            'GetPredefinedListResponse' => '\\StructType\\GetPredefinedListResponse',
            'GetQuotas' => '\\StructType\\GetQuotas',
            'GetQuotasResponse' => '\\StructType\\GetQuotasResponse',
            'GetQuota' => '\\StructType\\GetQuota',
            'GetQuotaResponse' => '\\StructType\\GetQuotaResponse',
            'DeleteRouting' => '\\StructType\\DeleteRouting',
            'DeleteRoutingResponse' => '\\StructType\\DeleteRoutingResponse',
            'DeleteQuestionnaire' => '\\StructType\\DeleteQuestionnaire',
            'DeleteQuestionnaireResponse' => '\\StructType\\DeleteQuestionnaireResponse',
            'GetFormByName' => '\\StructType\\GetFormByName',
            'GetFormByNameResponse' => '\\StructType\\GetFormByNameResponse',
            'GetForm' => '\\StructType\\GetForm',
            'GetFormResponse' => '\\StructType\\GetFormResponse',
            'GetNode' => '\\StructType\\GetNode',
            'GetNodeResponse' => '\\StructType\\GetNodeResponse',
            'GetNodes' => '\\StructType\\GetNodes',
            'GetNodesResponse' => '\\StructType\\GetNodesResponse',
            'GetFormsInLoop' => '\\StructType\\GetFormsInLoop',
            'GetFormsInLoopResponse' => '\\StructType\\GetFormsInLoopResponse',
            'GetLoopStructure' => '\\StructType\\GetLoopStructure',
            'GetLoopStructureResponse' => '\\StructType\\GetLoopStructureResponse',
            'GetConditionBranch' => '\\StructType\\GetConditionBranch',
            'GetConditionBranchResponse' => '\\StructType\\GetConditionBranchResponse',
            'GetRouting' => '\\StructType\\GetRouting',
            'GetRoutingResponse' => '\\StructType\\GetRoutingResponse',
            'Update' => '\\StructType\\Update',
            'UpdateResponse' => '\\StructType\\UpdateResponse',
            'GetSurveyStatus' => '\\StructType\\GetSurveyStatus',
            'GetSurveyStatusResponse' => '\\StructType\\GetSurveyStatusResponse',
            'SetSurveyStatus' => '\\StructType\\SetSurveyStatus',
            'SetSurveyStatusResponse' => '\\StructType\\SetSurveyStatusResponse',
            'GetExternalAnswers' => '\\StructType\\GetExternalAnswers',
            'GetExternalAnswersResponse' => '\\StructType\\GetExternalAnswersResponse',
            'ArrayOfAnswerBase' => '\\ArrayType\\ArrayOfAnswerBase',
            'ProjectExists' => '\\StructType\\ProjectExists',
            'ProjectExistsResponse' => '\\StructType\\ProjectExistsResponse',
            'GetBenchmarkProjectIds' => '\\StructType\\GetBenchmarkProjectIds',
            'GetBenchmarkProjectIdsResponse' => '\\StructType\\GetBenchmarkProjectIdsResponse',
            'GetProjectEmailObjects' => '\\StructType\\GetProjectEmailObjects',
            'GetProjectEmailObjectsResponse' => '\\StructType\\GetProjectEmailObjectsResponse',
            'ArrayOfEmailObject' => '\\ArrayType\\ArrayOfEmailObject',
            'EmailObject' => '\\StructType\\EmailObject',
        );
    }
}
